/* (c) Peter Mueller 2010 */
/* Command line options: -Trace -p ssc -l cx -o light automatic_light.xml   */
/* This file is generated from automatic_light.xml - do not edit manually  */
/* Generated on: Mon Oct 25 19:43:10 CEST 2010 / version 2.1.3 */


#include <stdio.h>
#include "light_ext.h"
#include "light.h"
#include "light_hlp.h"

void lamp(LIGHT_STATE_T state){
   if(state==ON){
      printf("Light is on\n");
   }else{
      printf("Light is off\n");
   }
}

int delayCnt=0;
extern int thermalFB;
extern int modeSwitch;

void   light(LIGHT_INSTANCEDATA_T *instanceVar, LIGHT_EVENT_T msg){

	LIGHT_EV_CONSUMED_FLAG_T evConsumed = 0U;

	
	/*execute entry code of default state once to init machine */
	if(instanceVar->offmanualEntry==1U){
		lamp(OFF);

		instanceVar->offmanualEntry=0U;
	}

	/* action code */
	


	switch (instanceVar->stateVar) {

		case AutoMode:

			switch (instanceVar->stateVarAutoMode) {

				case AutoLightOff:
					if(msg==(LIGHT_EVENT_T)evDawn){
						/* Transition from AutoLightOff to AutoAwaitTwilight */
						evConsumed=1U;

						/* OnEntry code of state AutoAwaitTwilight */
						lamp(OFF);

						/* adjust state variables  */
						lightChangeToStateAutoMode(instanceVar,AutoAwaitTwilight);
						lightTraceEvent(1U);
					}else if(msg==(LIGHT_EVENT_T)evNoThermalFB){
						/* Transition from AutoLightOff to AutoLightOff */
						evConsumed=1U;

						/* Action code for transition  */
						delayCnt=0;


						/* adjust state variables  */
						lightChangeToStateAutoMode(instanceVar,AutoLightOff);
						lightTraceEvent(2U);
					}else if(msg==(LIGHT_EVENT_T)evThermalFB){
						if(delayCnt==20){
							/* Transition from AutoLightOff to AutoLightOn */
							evConsumed=1U;

							/* Action code for transition  */
							delayCnt=0;

							/* OnEntry code of state AutoLightOn */
							lamp(ON);

							/* adjust state variables  */
							lightChangeToStateAutoMode(instanceVar,AutoLightOn);
							lightTraceEvent(8U);
						}else if(delayCnt<20){
							/* Transition from AutoLightOff to AutoLightOff */
							evConsumed=1U;

							/* Action code for transition  */
							delayCnt++;


							/* adjust state variables  */
							lightChangeToStateAutoMode(instanceVar,AutoLightOff);
							lightTraceEvent(7U);
						}else{
							/* Intentionally left blank */
						} /*end of event selection */
					}else{
						/* Intentionally left blank */
					} /*end of event selection */
				break; /* end of case AutoLightOff  */

				case AutoLightOn:
					/* action code  */
					delayCnt++;
					printf(".");

					if(delayCnt==60){
						/* Transition from AutoLightOn to AutoPrepareOff */
						evConsumed=16U;


						/* adjust state variables  */
						lightChangeToStateAutoMode(instanceVar,AutoPrepareOff);
						lightTraceEvent(4U);
					}else{
						/* Intentionally left blank */
					} /*end of event selection */
				break; /* end of case AutoLightOn  */

				case AutoPrepareOff:
					if(msg==(LIGHT_EVENT_T)evNoThermalFB){
						/* Transition from AutoPrepareOff to AutoLightOff */
						evConsumed=1U;

						/* Action code for transition  */
						lamp(OFF);


						/* adjust state variables  */
						lightChangeToStateAutoMode(instanceVar,AutoLightOff);
						lightTraceEvent(2U);
					}else if(msg==(LIGHT_EVENT_T)evThermalFB){
						/* Transition from AutoPrepareOff to AutoPrepareOff */
						evConsumed=1U;


						/* adjust state variables  */
						lightChangeToStateAutoMode(instanceVar,AutoPrepareOff);
						lightTraceEvent(3U);
					}else{
						/* Intentionally left blank */
					} /*end of event selection */
				break; /* end of case AutoPrepareOff  */

				case AutoAwaitTwilight:
					if(msg==(LIGHT_EVENT_T)evTwilight){
						/* Transition from AutoAwaitTwilight to AutoLightOff */
						evConsumed=1U;

						/* Action code for transition  */
						delayCnt=0;


						/* adjust state variables  */
						lightChangeToStateAutoMode(instanceVar,AutoLightOff);
						lightTraceEvent(0U);
					}else{
						/* Intentionally left blank */
					} /*end of event selection */
				break; /* end of case AutoAwaitTwilight  */

				default:
					/* Intentionally left blank */
				break;
			} /* end switch AutoMode */

		/* Check if event was already processed  */
		if(evConsumed==0U){

			if(modeSwitch==MODE_OFF){
				/* Transition from AutoMode to OffManual */
				evConsumed=16U;
				
				if(instanceVar->stateVarAutoMode==AutoLightOff){


				}else if(instanceVar->stateVarAutoMode==AutoLightOn){


				}else if(instanceVar->stateVarAutoMode==AutoPrepareOff){


				}else if(instanceVar->stateVarAutoMode==AutoAwaitTwilight){

				}


				/* OnEntry code of state OffManual */
				lamp(OFF);

				/* adjust state variables  */
				lightChangeToState(instanceVar,OffManual);
				lightTraceEvent(5U);
			}else{
				/* Intentionally left blank */
			} /*end of event selection */
		}
		break; /* end of case AutoMode  */

		case OffManual:
			if(modeSwitch==MODE_AUTO){
				/* Transition from OffManual to AutoAwaitTwilight */
				evConsumed=16U;

				/* OnEntry code of state AutoMode */
				// Entry Code Empty

				/* OnEntry code of state AutoAwaitTwilight */
				lamp(OFF);

				/* adjust state variables  */
				lightChangeToState(instanceVar,AutoMode);
				lightChangeToStateAutoMode(instanceVar,AutoAwaitTwilight);
				lightTraceEvent(9U);
			}else if(modeSwitch==MODE_ON){
				/* Transition from OffManual to OnManual */
				evConsumed=16U;

				/* OnEntry code of state OnManual */
				lamp(ON);

				/* adjust state variables  */
				lightChangeToState(instanceVar,OnManual);
				lightTraceEvent(6U);
			}else{
				/* Intentionally left blank */
			} /*end of event selection */
		break; /* end of case OffManual  */

		case OnManual:
			if(modeSwitch==MODE_OFF){
				/* Transition from OnManual to OffManual */
				evConsumed=16U;

				/* OnEntry code of state OffManual */
				lamp(OFF);

				/* adjust state variables  */
				lightChangeToState(instanceVar,OffManual);
				lightTraceEvent(5U);
			}else{
				/* Intentionally left blank */
			} /*end of event selection */
		break; /* end of case OnManual  */

		default:
			/* Intentionally left blank */
		break;
	} /* end switch stateVar_root */
}
